> ## Documentation Index
> Fetch the complete documentation index at: https://developer.lemlist.com/llms.txt
> Use this file to discover all available pages before exploring further.

> Edits variant B content and config of the A/B test on an email step.

# Update A/B Test Variant

<Note>
  A/B testing requires at least the **Email Pro** plan.
</Note>

Updates the **variant B** email template of the A/B test. Only the fields you
include in the request body are changed; variant A is never touched.

## Request Body

| Field        | Type             | Description                                     |
| ------------ | ---------------- | ----------------------------------------------- |
| `subject`    | string           | Variant B email subject. Maximum 400 characters |
| `message`    | string           | Variant B email body (HTML)                     |
| `altMessage` | string           | Alternate message                               |
| `cc`         | array of strings | CC recipients                                   |
| `plainText`  | boolean          | Send as plain text                              |

If the step does not run an A/B test, the endpoint returns `404`.


## OpenAPI

````yaml patch /sequences/{sequenceId}/steps/{stepId}/ab-test
openapi: 3.0.0
info:
  title: lemlist API
  version: 1.0.0
  description: >-
    Welcome to the lemlist Developer Documentation.


    lemlist is very customizable and open. You'll find on this page all the API
    and integration you can do with lemlist.


    # Rate Limit


    lemlist's API rate limits requests in order to prevent abuse and overload of
    our services.  

    Rate limits are applied on all routes and per API key performing the
    request.  

    The rate limits are **20** requests per **2** seconds.  

    The response provides any information you may need about it:


    | Header | Description |

    | --- | --- |

    | Retry-After | The number of seconds in which you can retry |

    | X-RateLimit-Limit | The maximum requests in that time |

    | X-RateLimit-Remaining | The number of remaining requests you can make |

    | X-RateLimit-Reset | The date when the rate limit will reset |


    _Example of values for the rate limit headers_


    ``` json

    {
        "Retry-After": 2,
        "X-RateLimit-Limit": 20,
        "X-RateLimit-Remaining": 7,
        "X-RateLimit-Reset" : "Tue Feb 16 2021 09:02:42 GMT+0100 (Central European Standard Time)"
    }

     ```

    # Definitions


    ## Team


    A team is the entity of lemlist that can handle users and billing.


    ## Credits


    Credits are the coins a team uses to enrich emails, LinkedIn URLs, etc. via
    the enrich route. Each enrichment feature needs a certain amount of credits
    to run.


    ## User


    You use a user account to connect to lemlist and send messages via the
    connected emails or LinkedIn account.


    ## Campaign


    A campaign is the entity to automate outreach. A campaign has multiple
    sequences composed of steps.


    ## Lead


    A lead is a person that you try to contact via a campaign.


    ## Activity


    An activity is the history of all the steps.


    ## Unsubscribe


    An unsubscribe occurs when a person decides they don't want to receive
    emails from you anymore.


    # Authentication


    All API routes use the dedicated subdomain `api.lemlist.com`.


    lemlist uses API keys to allow access to the API. You can get your lemlist
    API key at our [integration
    page](https://app.lemlist.com/settings/integrations).


    You need to add the `Authorization` header using the `Basic` authentication
    type. `login:password` **where the login is always empty and the password is
    the API key**.


    ⚠️ **Don't forget to add the semicolon (**`:`**) before your API key in curl
    command.**


    > To authorize, use this code: 
      

    ``` shell

    curl https://api.lemlist.com/api/team \
      --user ":YourApiKey"

     ```

    **Make sure to replace** **`YourApiKey`** **with your API key.**


    # Give feedback


    If you want to report a bug, ask for data, or share with us a use case,
    please fill this [form](https://lemlist.typeform.com/to/mfVlkyGf). It will
    help us centralize your needs!
servers:
  - url: https://api.lemlist.com/api
security:
  - basicAuth: []
paths:
  /sequences/{sequenceId}/steps/{stepId}/ab-test:
    parameters:
      - name: sequenceId
        in: path
        required: true
        description: The unique identifier of the sequence
        example: seq_lkCSKd32qSZZTe5Ru
        schema:
          type: string
      - name: stepId
        in: path
        required: true
        description: The unique identifier of the step
        example: stp_V0JHmSpWiO0rxHUkz
        schema:
          type: string
    patch:
      tags:
        - Sequences
      summary: Update A/B Test Variant
      description: >-
        Edits variant B content/config of the A/B test on an email step. Only
        the provided fields are updated. Requires the Email Pro plan.
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                subject:
                  type: string
                  description: Variant B email subject. Maximum 400 characters
                message:
                  type: string
                  description: Variant B email body (HTML)
                altMessage:
                  type: string
                cc:
                  type: array
                  items:
                    type: string
                plainText:
                  type: boolean
            example:
              subject: New subject B
              message: <div>New body B</div>
      responses:
        '200':
          description: Variant B updated
          content:
            application/json:
              schema:
                type: object
                properties:
                  stepId:
                    type: string
                  abTest:
                    oneOf:
                      - type: boolean
                      - type: string
                        enum:
                          - A
                          - B
                  emailTemplateBId:
                    type: string
                    description: Email template ID of variant B
                  subject:
                    type: string
                    description: Variant B email subject
                  message:
                    type: string
                    description: Variant B email body (HTML)
                  altMessage:
                    type: string
                  cc:
                    type: array
                    items:
                      type: string
                  plainText:
                    type: boolean
              example:
                stepId: stp_V0JHmSpWiO0rxHUkz
                abTest: true
                emailTemplateBId: etp_9aZ2k1QwErTyUiOp3
                subject: Quick question, {{firstName}}
                message: <div>Hi {{firstName}}, ...</div>
        '400':
          description: Bad request (invalid request body)
          content:
            text/plain:
              example: 'Match error: Expected string, got number'
        '401':
          description: The authentication you supplied is incorrect
          content:
            text/plain:
              example: The authentication you supplied is incorrect
        '402':
          description: A/B testing requires at least the Email Pro plan
          content:
            text/plain:
              example: route is available starting emailPro plan
        '404':
          description: Sequence, step, or A/B test variant not found
          content:
            text/plain:
              example: No A/B test variant on this step
        '405':
          description: Method not allowed
components:
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````